# Create repository

POST https://app.launchdarkly.com/api/v2/code-refs/repositories
Content-Type: application/json

Create a repository with the specified name.

Reference: https://launchdarkly.com/docs/api/code-references/post-repository

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/code-refs/repositories:
    post:
      operationId: post-repository
      summary: Create repository
      description: Create a repository with the specified name.
      tags:
        - subpackage_codeReferences
      parameters:
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Repository response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RepositoryRep'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorRep'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorRep'
        '409':
          description: Status conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StatusConflictErrorRep'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedErrorRep'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/repositoryPost'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    RepositoryPostType:
      type: string
      enum:
        - bitbucket
        - custom
        - github
        - gitlab
      description: >-
        The type of repository. If not specified, the default value is
        <code>custom</code>.
      title: RepositoryPostType
    repositoryPost:
      type: object
      properties:
        name:
          type: string
          description: The repository name
        sourceLink:
          type: string
          description: A URL to access the repository
        commitUrlTemplate:
          type: string
          description: A template for constructing a valid URL to view the commit
        hunkUrlTemplate:
          type: string
          description: A template for constructing a valid URL to view the hunk
        type:
          $ref: '#/components/schemas/RepositoryPostType'
          description: >-
            The type of repository. If not specified, the default value is
            <code>custom</code>.
        defaultBranch:
          type: string
          description: >-
            The repository's default branch. If not specified, the default value
            is <code>main</code>.
      required:
        - name
      title: repositoryPost
    RepositoryRepType:
      type: string
      enum:
        - bitbucket
        - custom
        - github
        - gitlab
      description: The type of repository
      title: RepositoryRepType
    UnixMillis:
      type: integer
      format: int64
      title: UnixMillis
    HunkRep:
      type: object
      properties:
        startingLineNumber:
          type: integer
          description: Line number of beginning of code reference hunk
        lines:
          type: string
          description: Contextual lines of code that include the referenced feature flag
        projKey:
          type: string
          description: The project key
        flagKey:
          type: string
          description: The feature flag key
        aliases:
          type: array
          items:
            type: string
          description: An array of flag key aliases
      required:
        - startingLineNumber
      title: HunkRep
    ReferenceRep:
      type: object
      properties:
        path:
          type: string
          description: File path of the reference
        hint:
          type: string
          description: Programming language used in the file
        hunks:
          type: array
          items:
            $ref: '#/components/schemas/HunkRep'
      required:
        - path
        - hunks
      title: ReferenceRep
    BranchRep:
      type: object
      properties:
        name:
          type: string
          description: The branch name
        head:
          type: string
          description: An ID representing the branch HEAD. For example, a commit SHA.
        updateSequenceId:
          type: integer
          format: int64
          description: >-
            An optional ID used to prevent older data from overwriting newer
            data
        syncTime:
          $ref: '#/components/schemas/UnixMillis'
          description: A timestamp indicating when the branch was last synced
        references:
          type: array
          items:
            $ref: '#/components/schemas/ReferenceRep'
          description: An array of flag references found on the branch
        _links:
          type: object
          additionalProperties:
            description: Any type
          description: The location and content type of related resources
      required:
        - name
        - head
        - syncTime
        - _links
      title: BranchRep
    ActionIdentifier:
      type: string
      title: ActionIdentifier
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    AccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessDeniedReasonEffect
    AccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessDeniedReason
    AccessDenied:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessDeniedReason'
      required:
        - action
        - reason
      title: AccessDenied
    AccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessAllowedReasonEffect
    AccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessAllowedReason
    AccessAllowedRep:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessAllowedReason'
      required:
        - action
        - reason
      title: AccessAllowedRep
    Access:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AccessAllowedRep'
      required:
        - denied
        - allowed
      title: Access
    RepositoryRep:
      type: object
      properties:
        name:
          type: string
          description: The repository name
        sourceLink:
          type: string
          description: A URL to access the repository
        commitUrlTemplate:
          type: string
          description: A template for constructing a valid URL to view the commit
        hunkUrlTemplate:
          type: string
          description: A template for constructing a valid URL to view the hunk
        type:
          $ref: '#/components/schemas/RepositoryRepType'
          description: The type of repository
        defaultBranch:
          type: string
          description: The repository's default branch
        enabled:
          type: boolean
          description: Whether or not a repository is enabled for code reference scanning
        version:
          type: integer
          description: The version of the repository's saved information
        branches:
          type: array
          items:
            $ref: '#/components/schemas/BranchRep'
          description: >-
            An array of the repository's branches that have been scanned for
            code references
        _links:
          type: object
          additionalProperties:
            description: Any type
        _access:
          $ref: '#/components/schemas/Access'
      required:
        - name
        - type
        - defaultBranch
        - enabled
        - version
        - _links
      title: RepositoryRep
    InvalidRequestErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: InvalidRequestErrorRep
    UnauthorizedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: UnauthorizedErrorRep
    ForbiddenErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: ForbiddenErrorRep
    StatusConflictErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: StatusConflictErrorRep
    RateLimitedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: RateLimitedErrorRep
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/code-refs/repositories"

payload = { "name": "LaunchDarkly-Docs" }
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/code-refs/repositories';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"LaunchDarkly-Docs"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/code-refs/repositories"

	payload := strings.NewReader("{\n  \"name\": \"LaunchDarkly-Docs\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/code-refs/repositories")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"LaunchDarkly-Docs\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/code-refs/repositories")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"LaunchDarkly-Docs\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/code-refs/repositories', [
  'body' => '{
  "name": "LaunchDarkly-Docs"
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/code-refs/repositories");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"LaunchDarkly-Docs\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["name": "LaunchDarkly-Docs"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/code-refs/repositories")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```